<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <title>Province</title>
</head>

<body>

  <div>
    <h2 class="text-center">Devcamp - Province - Rest API - Front End - Task 62</h2>
  </div><br>
  <div class="container jumbotron border bordered">
    <div class="row form-group">
      <div class="col-sm-2">
        <label>Province</label>
      </div>
      <div class="col-sm-4">
        <select class="form-control" id="s-province">
          <option value="0">-- Chọn Province --</option>
        </select>
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-2">
        <label>District</label>
      </div>
      <div class="col-sm-4">
        <select class="form-control" id="s-district">
          <option value="none">-- Chọn District --</option>
        </select>
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-2">
        <label>Ward</label>
      </div>
      <div class="col-sm-4">
        <select class="form-control" id="s-ward">
          <option value="0">-- Chọn Ward --</option>
        </select>
      </div>
    </div>


  </div>
</body>
<script>
  var gElementProvince = $("#s-province");
  var gElementDistrict = $("#s-district");
  var gElementWard = $("#s-ward");

  $(document).ready(function () {
    onPageLoading();
    loadDataProvince();// Lấy dữ liệu lên bảng select province

    function onPageLoading() {
      console.log("Loading Page")
    }
    function loadDataProvince() {
      $.ajax({
        url: "http://localhost:8080/all-provinces-info",
        method: "GET",
        success: function (ResProvince) {
          console.log(ResProvince);
          loadDataToProvinceSelect(ResProvince);

        },
        error: function () {
          console.log("Không thể load");
        }
      });
    }
    function loadDataToProvinceSelect(paramResProvince) {
      for (i = 0; i < paramResProvince.length; i++) {
        var provinceOption = $("<option/>");
        provinceOption.prop("value", paramResProvince[i].id);
        provinceOption.prop("text", paramResProvince[i].name);
        gElementProvince.append(provinceOption);
      };
    }

    //Lấy Id của province khi có sự thay đổi lựa chọn
    gElementProvince.on("change", function () {
      var provinceId = $(this).val();
      if (provinceId != "none") {

        gElementDistrict.html("--Chọn District--");
        $("<option>", {
          value: "none",
          text: "--Chọn District--"
        }).appendTo(gElementDistrict);


        gElementWard.html("--Chọn Ward--");
        $("<option>", {
          value: "none",
          text: "--Chọn Ward--"
        }).appendTo(gElementWard);

        getDistrictByProvinceId(provinceId);
      } else {
        $("#s-district").value("none");
        $("#s-district").html("--Chọn District--");

      }
    });
    //Lấy danh sách các quận huyện của 1 thành phố hay 1 tỉnh
    function getDistrictByProvinceId(paramId) {
      $.ajax({
        url: "http://localhost:8080/district-in-province?id=" + paramId,
        method: "GET",
        success: function (ResDist) {
          console.log(ResDist);
          loadDataToDistrictSelect(ResDist);
        },
        error: function (Res) {
          console.log("Không Tải được nha bạn");
        }
      });
    }

    function loadDataToDistrictSelect(paramResDist) {

      if (paramResDist.length > 0) {

        for (i = 0; i < paramResDist.length; i++) {
          var districtOpt = $("<option/>");
          districtOpt.prop("value", paramResDist[i].id);
          districtOpt.prop("text", paramResDist[i].name);
          gElementDistrict.append(districtOpt);
        };
      }
    }
    //Lấy Id của quận khi có sự thay đổi lựa chọn
    gElementDistrict.on("change", function () {
      var districtId = $(this).val();
      if (districtId != "none") {
        $("#s-ward").empty(); //xóa trắng khi thay đổi Quận Huyện
        $("<option>", {
          value: "none",
          text: "--Chọn Ward--"
        }).appendTo(gElementWard);

        getWardByDistrictId(districtId);
      }
      else {

        $("#s-ward").empty();
        $("<option>", {
          value: "none",
          text: "--Chọn Ward--"
        }).appendTo(gElementWard);

      }
    });
    function getWardByDistrictId(paramId) {
      $.ajax({
        url: "http://localhost:8080/ward-in-district?id=" + paramId,
        method: "GET",
        success: function (ResWard) {
          console.log(ResWard);
          loadDataToWardSelect(ResWard);
        },
        error: function (Res) {
          console.log("Không Tải được nha bạn");
        }
      });
    }
    function loadDataToWardSelect(paramResWard) {

      if (paramResWard.length > 0) {

        for (i = 0; i < paramResWard.length; i++) {
          var wardOpt = $("<option/>");
          wardOpt.prop("value", paramResWard[i].id);
          wardOpt.prop("text", paramResWard[i].name);
          gElementWard.append(wardOpt);
        };
      }
    }




  });


</script>

</html>